<?php
/*********************************************************************
*@filename securities_controller.php
*@description oper_evtusers_controller 画面の機能クラス
*@note 
*@histories  rivision	author		date		comment
*            1.0        xinw        2008/10/16  modify for LV20R1-157
*            2.0        xinw        2008/10/22  modify for LV20R1-158
*            3.0        xinw        2008/11/14  modify for LV20R1-195
*            3.0        yzl        2009/09/14  modify for LogvillageChinese
********************************************************************/
class OperEvtusersController extends AppController
{
	var $helpers = array('Html', 'Javascript', 'Ajax','Pagination', 'Lv');
	var $components = array ('Pagination', 'Lv','Check');
	var $uses=array('Optuser','Group', 'Host','Rlthstgrp','Grpauth','Configure','Validation',
	"Grpshd", "Rltshdmod",'Hstactivelog');
	var $layout='oper';
	
	function beforeFilter()
	{
		parent::beforeFilter();
		if(isset($_POST['forHideVar'])){
			$this->set('forHideVar', $_POST['forHideVar']);
		}
		else if(isset($_POST['forHideVar1'])){
			$this->set('forHideVar', $_POST['forHideVar1']);
			$this->set('back', $_POST['forHideVar1']);
		}
	}
	function index()
	{
		$this->pageTitle = __('menu_oper',$return = true).'/'.__('log_onlog_off',$return = true);
		$own_user_id = $this->_getUserGroup();
		$glist = $this->Group->getChildrenByParent($own_user_id);
		$this->set('glist',$glist);
		
		$dir=LOG_LIMIT;
		$ini_array = parse_ini_file($dir,true);
		if (!empty($ini_array)){
			if(!empty($ini_array['Option']['ShowGraph']) && $ini_array['Option']['ShowGraph'] == "1")
				$this->set('show_graph', 1);
		}//$this->set('show_graph', 1);
	}
	function search($judg = null,$acpc = null,$tim = null,$csv = null)
	{
		(!empty($_SESSION['data_detail']))?session_unregister('data_detail'):"";
		$this->layout='ajax';
		$dt= date('Y-m-d',time());
		$criteria = array();
		if($tim == 1){
			if(isset($this->data['dt_check'][0])){
				unset($this->data['dt_check'][0]);
			}
		}
		$by_kw = $this->Lv->operSearch();
		$by_dt = $this->Lv->optionsDatetime2("Hstactivelog-start");
		$err=array();
		if(isset($this->data['Host']['host_name']))
		{
			if(!$this->Check->checkAllHalf($this->data['Host']['host_name']))
			{
				$err['client_pc_name'][] = 'E-00400';
			}
			if(!$this->Validation->maxLength($this->data['Host']['host_name'],127))
			{
				$err['client_pc_name'][] = 'E-00300';
			}
		}
		if(isset($this->data['Hstactivelog']['account']))
		{
			if(!$this->Validation->maxLength($this->data['Hstactivelog']['account'],127))
			{
				$err['logon account'][] = 'E-00300';
			}
		}
		if(!empty($by_kw['error']) || !empty($by_dt['error']) || !empty($err))
		{
			empty($by_kw['error']) ? null : $this->set('by_kw_err',$by_kw['error']);
			empty($by_dt['error']) ? null : $this->set('by_dt_err',$by_dt['error']);
			empty($err) ? $err = array() : $this->set('err',$err);
			$this->render();
			exit();
		}
		if(empty($by_dt) && empty($by_kw))
		{
			$criteria[]="datepart(Hstactivelog.start)= '".$dt."'";
		}
		else
		{
			empty($by_kw) ? null : $criteria[] = implode(' and ', $by_kw);
			empty($by_dt) ? null : $criteria[] = implode(' and ', $by_dt);
		}
		$criteria[]="Hstactivelog.account IS NOT NULL";
		
		if($judg == '1'){//ログオンアカウント毎
		$acpc=$this->Lv->url_param_decode2($acpc);
			$criteria[] = " lower(Hstactivelog.account) = '".strtolower($this->Lv->spec_char_dbm($acpc))."' ";
			if(empty($tim)){
				isset($_POST['forHideVar1'])?$this->set('forHideVar', $_POST['forHideVar1']."&data%5BOptuser%5D%5Baccount%5D=$acpc"):null;
				isset($_POST['forHideVar'])?$this->set('forHideVar', $_POST['forHideVar']."&data%5BOptuser%5D%5Baccount%5D=$acpc"):null;
				$this->acdate($criteria,$acpc);
			}
			else{
				if($tim==1){
					$this->detail($criteria,$acpc,$tim,$judg);
				}
				elseif($tim=='csv'){
					isset($_POST['forHideVar1'])?$this->set('forHideVar', $_POST['forHideVar1']."&data%5BOptuser%5D%5Baccount%5D=$acpc"):null;
					isset($_POST['forHideVar'])?$this->set('forHideVar', $_POST['forHideVar']."&data%5BOptuser%5D%5Baccount%5D=$acpc"):null;
					$this->acdate($criteria,$acpc,$tim,$by_dt);
				}
				else{
					$criteria[] = "DATEPART(Hstactivelog.start) = '".$tim."' ";
					$this->detail($criteria,$acpc,$tim,$judg,$csv);
				}
			}
		}
		elseif($judg == '2'){//コンピュータ名毎
		$acpc=$this->Lv->url_param_decode2($acpc);
			$criteria[] = " lower(Host.host_name) = '".strtolower($this->Lv->spec_char_dbm($acpc))."' ";
			if(empty($tim)){
				isset($_POST['forHideVar1'])?$this->set('forHideVar', $_POST['forHideVar1']."&data%5BHost%5D%5Bhost_name%5D=$acpc"):null;
				isset($_POST['forHideVar'])?$this->set('forHideVar', $_POST['forHideVar']."&data%5BHost%5D%5Bhost_name%5D=$acpc"):null;
				$this->pcdate($criteria,$acpc);
			}
			else{
				if($tim==1){
					$this->detail($criteria,$acpc,$tim,$judg,$csv);
				}
				elseif($tim=='csv'){
					isset($_POST['forHideVar1'])?$this->set('forHideVar', $_POST['forHideVar1']."&data%5BHost%5D%5Bhost_name%5D=$acpc"):null;
					isset($_POST['forHideVar'])?$this->set('forHideVar', $_POST['forHideVar']."&data%5BHost%5D%5Bhost_name%5D=$acpc"):null;
					$this->pcdate($criteria,$acpc,$tim);
				}
				else{
					$criteria[] = "DATEPART(Hstactivelog.start) = '".$tim."' ";
					$this->detail($criteria,$acpc,$tim,$judg,$csv);
				}
			}
		}
		else{
			if($this->data['Optuser']['account_pc']=='1')
			{
				if($this->data['Graph']['check']=='1')
					$this->pcgraph($criteria,$judg,$by_dt);
				else
					$this->pc($criteria,$judg,$by_dt);
			}
			else
			{
				$_SESSION['by_dt'] = $by_dt;
				if($this->data['Graph']['check']=='1')
					$this->accountgraph($criteria,$judg,$by_dt);
				else
					$this->account($criteria,$judg,$by_dt);
			}
		}
	}
	function getgrpid($id)
	{
		$glist = $this->Grpauth->getChildrenByParent($id);
		$condition="";
		foreach($glist as $key => $value){
			$condition.=$key.",";
		}
		$condition = substr($condition,0,-1);
		$search_str=" Rlthstgrp.group_id in (".$condition.") ";
		return $search_str;
	}
	
	//ログオンアカウント毎に表示する 1ページ目
	function account(& $criteria,$type=null,$by_dt=null)
	{
		$interval = $this->getInterval();
		$this->layout='ajax';
		if($this->data['Optuser']['group']=='0' || empty($this->data['Optuser']['group']))
		{
			$own_user_id = $this->_getUserGroup();
			$criteria[]=$this->getgrpid($own_user_id);
		}else
		{
			$criteria[]=$this->getgrpid($this->data['Optuser']['group']);
		}
		$criteri_detail=$criteria;
		$_SESSION['criteri_detail']=$criteri_detail;
		$criteria['GROUP BY']="Hstactivelog.account";
		
		$asso = array(
			'Host : hosts' => array('Hstactivelog.host_id = Host.id'),
			'Rlthstgrp : rlthstgrps' => array('Hstactivelog.host_id = Rlthstgrp.host_id'),
		);
		$order_now="Hstactivelog.account";
		$fields = array(
			"Hstactivelog.account as Temp__name",
			"sum(case when Hstactivelog.start is not null then 1 else 0 end) as Temp__login",
			"sum(case when Hstactivelog.stop is not null then 1 else 0 end) as Temp__logout",
			"sum(case when Hstactivelog.stop is null and TIMESTAMPDIFF(SECOND, Hstactivelog.active, now()) > ".$interval." then 1 else 0 end) as Temp__logerr",
		);
		if($type=='csv'){
			$all_data = $this->Hstactivelog->findByAsso($criteria, $fields,
									$order_now,null,null,$asso);
			$this->csvdown($criteria,$all_data,1);
			exit;
		}
		list($order,$limit,$page) = $this->Pagination->init($criteria, null, array('ajaxDivUpdate'=>'search', 'url'=>'/oper_evtusers/search', 'modelClass'=>'Hstactivelog', 'queryType' => array('function' => 'findByAsso', 'asso' => $asso), 'sortBy' => $this->Lv->sortBy($order_now)));
		$data = $this->Hstactivelog->findByAsso($criteria, $fields,
									$order,$limit,$page,$asso);
		
		$this->set('data',$data);
		
		$total=0;
		foreach ($data as $da)
		{
			$total+=$da['Temp']['login'];
			$total+=$da['Temp']['logout'];
			$total+=$da['Temp']['logerr'];
		}
		$this->set('total',$total);

		$this->render('account_wasay');
	}
	function account_old(& $criteria,$type=null,$by_dt=null)
	{
		$this->layout='ajax';
		
		if($this->data['Optuser']['group']=='0' || empty($this->data['Optuser']['group']))
		{
			$own_user_id = $this->_getUserGroup();
			$criteria[]=$this->getgrpid($own_user_id);
		}else
		{
			$criteria[]=$this->getgrpid($this->data['Optuser']['group']);
		}
		$criteria3 = $criteria;
		$criteria[]="Optuser.log_status in (1,2)";
		$criteria[]=" Optuser.account <> '' ";
		$criteri_detail=$criteria;
		$_SESSION['criteri_detail']=$criteri_detail;
		$_SESSION['criteri_3']=$criteria3;
		$criteria['GROUP BY']="Optuser__account,Optuser.log_status";

		$order_all="Optuser__account";
		
		$asso = array('Host : hosts' => array('Optuser.host_id = Host.id'),
		'Rlthstgrp : rlthstgrps' => array('Optuser.host_id = Rlthstgrp.host_id'),
		);
		//0異常終了1ログオン2ログオフの回数を取得
		$opts = $this->Optuser->findByAsso($criteria, array("lower(Optuser.account) as Optuser__account,Optuser.log_status as Optuser__log_status,count(Optuser.log_status) as Optuser__con"),
									$order_all,null,null,$asso);
									
//wasay用
//アカウント毎の切断回数をだす(2ログオフがなくて5切断があるか)
		$logerrs =  $this->GetDisconnect($criteria,$asso,'account',$by_dt);//debug($logerrs);
		//echo "logerrs";debug ($logerrs);
		//echo "opts";debug ($opts);
		$logonoffnum = array();
		
		for ($i=0;$i<count($opts);$i++){
			$name = strtolower($opts[$i]['Optuser']['account']);
			$logonoffnum[$name][$opts[$i]['Optuser']['log_status']] = $opts[$i]['Optuser']['con'];
		}

		$result = $this->Optuser->query('CREATE TEMPORARY TABLE temppsoptusers (id serial, name  varchar(127), login integer,logout integer,logerr integer)');
		if($result === false){
			debug("CREATE TEMPORARY TABLE failed!", true);
		}
		foreach ($logonoffnum as $key => $value){
			$login = 0;
			$logout = 0;
			$logerr = 0;

			if(isset($logerrs[$key])){
				$logerr = $logerrs[$key];
			}
			if(isset($value[0]))
				$logerr += $value[0];
			if(isset($value[1]))
				$login = $value[1];
			if(isset($value[2]))
				$logout = $value[2];
			
			$this->Optuser->query("INSERT INTO temppsoptusers VALUES(null,'{$this->Lv->spec_char_dbm($key)}', {$login}, {$logout}, {$logerr});");
		}		

		$this->addModel("Temp");
		$this->Temp->useTable = "temppsoptusers";
		$order_now = "Temp.name";
		$condition = array("1=1");
		list($order,$limit,$page) = $this->Pagination->init($condition, null, array('ajaxDivUpdate'=>'search', 'url'=>'/oper_evtusers/search', 'modelClass'=>'Temp', 'queryType' => array('function' => 'findByAsso'), 'sortBy' => $this->Lv->sortBy($order_now)));
		$data = $this->Temp->findByAsso($condition, array("Temp.name as Temp__name,Temp.login as Temp__login,Temp.logout as Temp__logout,Temp.logerr as Temp__logerr"),$order,$limit,$page);

		$total=0;
		foreach ($data as $da)
		{
			$total+=$da['Temp']['login'];
			$total+=$da['Temp']['logout'];
			$total+=$da['Temp']['logerr'];
		}
		$this->set('total',$total);

		empty($data)? $data=array():$data;
		$this->set('data',$data);
		if($type=='csv'){
			$all_data = $this->Temp->findByAsso($condition, array("Temp.name as Temp__name,Temp.login as Temp__login,Temp.logout as Temp__logout,Temp.logerr as Temp__logerr"),$order,null,null);
			$this->csvdown($criteria,$all_data,1);exit;
		}
		$this->render('account_wasay');
	}
	function accountgraph(& $criteria,$type=null,$by_dt=null)
	{
		$interval = $this->getInterval();
		$this->layout='ajax';
		if($this->data['Optuser']['group']=='0' || empty($this->data['Optuser']['group']))
		{
			$own_user_id = $this->_getUserGroup();
			$criteria[]=$this->getgrpid($own_user_id);
		}else
		{
			$criteria[]=$this->getgrpid($this->data['Optuser']['group']);
		}
		$criteria['GROUP BY']="Hstactivelog.account";
		
		$asso = array(
			'Host : hosts' => array('Hstactivelog.host_id = Host.id'),
			'Rlthstgrp : rlthstgrps' => array('Hstactivelog.host_id = Rlthstgrp.host_id'),
		);
		$order_now="Hstactivelog.account";
		$fields = array(
			"Hstactivelog.account as Temp__name",
			"sum(case when Hstactivelog.start is not null then 1 else 0 end) as Temp__login",
			"sum(case when Hstactivelog.stop is not null then 1 else 0 end) as Temp__logout",
			"sum(case when Hstactivelog.stop is null and TIMESTAMPDIFF(SECOND, Hstactivelog.active, now()) > ".$interval." then 1 else 0 end) as Temp__logerr",
			"sum(
				case when Hstactivelog.stop is null then TIMESTAMPDIFF(MINUTE, Hstactivelog.start,Hstactivelog.active) 
				else TIMESTAMPDIFF(MINUTE, Hstactivelog.start,Hstactivelog.stop) end
				) as Temp__used_time"
		);
		if($type=='csv'){
			$all_data = $this->Hstactivelog->findByAsso($criteria, $fields,
									$order_now,null,null,$asso);
			$this->csvdown($criteria,$all_data,6);
			exit;
		}
		list($order,$limit,$page) = $this->Pagination->init($criteria, null, array('ajaxDivUpdate'=>'search', 'url'=>'/oper_evtusers/search', 'modelClass'=>'Hstactivelog', 'queryType' => array('function' => 'findByAsso', 'asso' => $asso), 'sortBy' => $this->Lv->sortBy($order_now)));
		$data = $this->Hstactivelog->findByAsso($criteria, $fields,
									$order,$limit,$page,$asso);
		
		$this->set('data',$data);
		
		$total=0;
		foreach ($data as $da)
		{
			$total+=$da['Temp']['login'];
			$total+=$da['Temp']['logout'];
			$total+=$da['Temp']['logerr'];
		}
		$this->set('total',$total);

		if($type!='csv'){
			$keys = Set::extract($data, '{n}.Temp.name');
			$vals = Set::extract($data, '{n}.Temp.used_time');
			$this->Session->write("graphxdata",$keys);
			$this->Session->write("graphydata",$vals);
			$this->Session->write("graphtitle", __('account_use_time',true));
		}
		$this->render('accountgraph');
	}
	function accountgraph_old(& $criteria,$type=null,$by_dt=null)
	{
		$this->layout='ajax';
		
		if($this->data['Optuser']['group']=='0' || empty($this->data['Optuser']['group']))
		{
			$own_user_id = $this->_getUserGroup();
			$criteria[]=$this->getgrpid($own_user_id);
		}else
		{
			$criteria[]=$this->getgrpid($this->data['Optuser']['group']);
		}
		$criteria3 = $criteria;
		$criteria[]="Optuser.log_status in (1,2)";
		$criteria[]="Optuser.AccessFrom = ''";
		$criteria[]=" Optuser.account <> '' ";
		$criteri_detail=$criteria;
		$_SESSION['criteri_detail']=$criteri_detail;
		$_SESSION['criteri_3']=$criteria3;
		$criteria['GROUP BY']="Optuser__account,Optuser.log_status";

		$order_all="Optuser__account";
		
		$asso = array('Host : hosts' => array('Optuser.host_id = Host.id'),
		'Rlthstgrp : rlthstgrps' => array('Optuser.host_id = Rlthstgrp.host_id'),
		);
		//0異常終了1ログオン2ログオフの回数を取得
		$fld = array(
			"lower(Optuser.account) as Optuser__account",
			"Optuser.log_status as Optuser__log_status",
			"count(Optuser.log_status) as Optuser__con"
		);
		$opts = $this->Optuser->findByAsso($criteria, $fld, $order_all, null, null, $asso);
									
//wasay用
//アカウント毎の切断回数をだす(2ログオフがなくて5切断があるか)
		$logerrs =  $this->GetDisconnect($criteria3,$asso,'account',$by_dt);//debug($logerrs);
		//echo "logerrs";debug ($logerrs);
		//echo "opts";debug ($opts);
		$logonoffnum = array();
		
		for ($i=0;$i<count($opts);$i++){
			$name = strtolower($opts[$i]['Optuser']['account']);
			$logonoffnum[$name][$opts[$i]['Optuser']['log_status']] = $opts[$i]['Optuser']['con'];
		}

		//接続時間
		$crit = $criteria3;
		$crit[]="Optuser.log_status = 1";
		$crit[]="Optuser.AccessFrom = ''";
		$crit[]="Optuser3.tslog is null";
		$crit['GROUP BY']="Optuser__account";
		$assos = array(
			'Host : hosts' => array('Optuser.host_id = Host.id'),
			'Rlthstgrp : rlthstgrps' => array('Optuser.host_id = Rlthstgrp.host_id'),
			'Optuser2 : optusers' => array(
				'Optuser.host_id = Optuser2.host_id',
				'Optuser.LogonID = Optuser2.LogonID',
				'Optuser.tslog < Optuser2.tslog',
				'Optuser2.log_status in (0, 2) ',),
			'Optuser3 : optusers : left' => array(
				'Optuser.host_id = Optuser3.host_id',
				'Optuser.account = Optuser3.account',
				'Optuser.tslog < Optuser3.tslog',
				'Optuser3.tslog < Optuser2.tslog',
				'Optuser3.log_status = 1 ',),
		);
		$field = array(
			"lower(Optuser.account) as Optuser__account",
			"sum(UNIX_TIMESTAMP(Optuser2.tslog) - UNIX_TIMESTAMP(Optuser.tslog))/60 as Optuser__minutes"
		//'sum(TIMESTAMPDIFF(SECOND, Optuser.tslog, Optuser2.tslog)/60) as Optuser__minutes'
		);
		$times =array();
		$tmp_times = $this->Optuser->findByAsso($crit, $field, "Optuser__account",null,null,$assos);
		if(!empty($tmp_times)){
			$keys = Set::extract($tmp_times, '{n}.Optuser.account');
			$vals = Set::extract($tmp_times, '{n}.Optuser.minutes');
			$times = array_combine($keys, $vals);
		}
		/*$times_add =  $this->GetDisconnectTime($criteria3,$asso,'account',$by_dt);;//var_dump($logerrs);
		foreach($times_add as $k => $t){
			if(isset($times[$k]))
				$times[$k] += $t;
		}*/
		//var_dump($times_add);
		
		$result = $this->Optuser->query('CREATE TEMPORARY TABLE temppsoptusers (id serial, name  varchar(127), login integer,logout integer,logerr integer,used_time integer)');
		if($result === false){
			debug("CREATE TEMPORARY TABLE failed!", true);
		}
		foreach ($logonoffnum as $key => $value){
			$login = 0;
			$logout = 0;
			$logerr = 0;

			if(isset($logerrs[$key])){
				$logerr = $logerrs[$key];
			}
			if(isset($value[0]))
				$logerr += $value[0];
			if(isset($value[1]))
				$login = $value[1];
			if(isset($value[2]))
				$logout = $value[2];
			
			$minutes = 0;
			if(isset($times[$key]))
				$minutes = $times[$key];
			
			$this->Optuser->query("INSERT INTO temppsoptusers VALUES(null,'{$this->Lv->spec_char_dbm($key)}', {$login}, {$logout}, {$logerr}, {$minutes});");
		}		

		$this->addModel("Temp");
		$this->Temp->useTable = "temppsoptusers";
		$order_now = "Temp.name";
		$condition = array("1=1");
		list($order,$limit,$page) = $this->Pagination->init($condition, null, array('ajaxDivUpdate'=>'search', 'url'=>'/oper_evtusers/search', 'modelClass'=>'Temp', 'queryType' => array('function' => 'findByAsso'), 'sortBy' => $this->Lv->sortBy($order_now)));
		$data = $this->Temp->findByAsso($condition, array("Temp.name as Temp__name,Temp.login as Temp__login,Temp.logout as Temp__logout,Temp.logerr as Temp__logerr,Temp.used_time as Temp__used_time"),$order,$limit,$page);

		$total=0;
		foreach ($data as $da)
		{
			$total+=$da['Temp']['login'];
			$total+=$da['Temp']['logout'];
			$total+=$da['Temp']['logerr'];
		}
		$this->set('total',$total);

		empty($data)? $data=array():$data;
		$this->set('data',$data);
		if($type=='csv'){
			$all_data = $this->Temp->findByAsso($condition, array("Temp.name as Temp__name,Temp.login as Temp__login,Temp.logout as Temp__logout,Temp.logerr as Temp__logerr,Temp.used_time as Temp__used_time"),$order,null,null);
			$this->csvdown($criteria,$all_data,6);exit;
		}else{
			$keys = Set::extract($data, '{n}.Temp.name');
			$vals = Set::extract($data, '{n}.Temp.used_time');
			$this->Session->write("graphxdata",$keys);
			$this->Session->write("graphydata",$vals);
			//$this->Session->write("graphxdata",array_keys($times));
			//$this->Session->write("graphydata",array_values($times));
			$this->Session->write("graphtitle", __('account_use_time',true));
		}
		$this->render('accountgraph');
	}
	//コンピュータ名毎に表示する 1ページ目
	function pc(& $criteria,$type=null,$by_dt=null)
	{
		$interval = $this->getInterval();
		$this->layout='ajax';
		if($this->data['Optuser']['group']=='0' || empty($this->data['Optuser']['group']))
		{
			$own_user_id = $this->_getUserGroup();
			$criteria[]=$this->getgrpid($own_user_id);
		}else
		{
			$criteria[]=$this->getgrpid($this->data['Optuser']['group']);
		}
		$criteria['GROUP BY']="Host.host_name";
		
		$asso = array(
			'Host : hosts' => array('Hstactivelog.host_id = Host.id'),
			'Rlthstgrp : rlthstgrps' => array('Hstactivelog.host_id = Rlthstgrp.host_id'),
		);
		$order_now="Hstactivelog.account";
		$fields = array(
			"Host.host_name as Temp__name",
			"sum(case when Hstactivelog.start is not null then 1 else 0 end) as Temp__login",
			"sum(case when Hstactivelog.stop is not null then 1 else 0 end) as Temp__logout",
			"sum(case when Hstactivelog.stop is null and TIMESTAMPDIFF(SECOND, Hstactivelog.active, now()) > ".$interval." then 1 else 0 end) as Temp__logerr",
		);
		if($type=='csv'){
			$all_data = $this->Hstactivelog->findByAsso($criteria, $fields,$order_now,null,null,$asso);
			$this->csvdown($criteria,$all_data,2);exit;
		}
		list($order,$limit,$page) = $this->Pagination->init($criteria, null, array('ajaxDivUpdate'=>'search', 'url'=>'/oper_evtusers/search', 'modelClass'=>'Hstactivelog', 'queryType' => array('function' => 'findByAsso', 'asso' => $asso), 'sortBy' => $this->Lv->sortBy($order_now)));
		$data = $this->Hstactivelog->findByAsso($criteria, $fields,
									$order,$limit,$page,$asso);
		$this->set('data',$data);
		
		$total=0;
		foreach ($data as $da)
		{
			$total+=$da['Temp']['login'];
			$total+=$da['Temp']['logout'];
			$total+=$da['Temp']['logerr'];
		}
		$this->set('total',$total);

		$this->render('pc_wasay');
	}
	//コンピュータ名毎に表示する  1ページ目
	function pc_old(& $criteria,$type=null,$by_dt=null)
	{

		$this->layout='ajax';
		if($this->data['Optuser']['group']=='0' || empty($this->data['Optuser']['group']))
		{
			$own_user_id = $this->_getUserGroup();
			$criteria[]=$this->getgrpid($own_user_id);
		}else
		{
			$criteria[]=$this->getgrpid($this->data['Optuser']['group']);
		}
		$criteria3 = $criteria;
		$criteria[]="Optuser.log_status in (1,2)";
		$criteria['GROUP BY']="Host.host_name,Optuser.log_status";
		$order_all="Host.host_name";
		$asso = array('Host : hosts' => array('Optuser.host_id = Host.id'),
		'Rlthstgrp : rlthstgrps' => array('Optuser.host_id = Rlthstgrp.host_id'),
		);
		
		//ホストのステータスごとに集計
		$opts = $this->Optuser->findByAsso($criteria, array("Host.host_name as Host__host_name,Optuser.log_status as Optuser__log_status,count(Optuser.log_status) as Optuser__con"),$order_all,null,null,$asso);
		
		//host毎の切断回数をだすwasay
		$logerrs =  $this->GetDisconnect($criteria3,$asso,'host',$by_dt);//debug($logerrs);
		$logonoffnum = array();
		for ($i=0;$i<count($opts);$i++){
			$name = strtolower($opts[$i]['Host']['host_name']);
			$logonoffnum[$name][$opts[$i]['Optuser']['log_status']] = $opts[$i]['Optuser']['con'];
		}//debug ($logonoffnum);
		
		
		$result = $this->Optuser->query('CREATE TEMPORARY TABLE temppsoptusers (id serial, name  varchar(127), login integer,logout integer,logerr integer)');
		if($result === false){
			debug("CREATE TEMPORARY TABLE failed!", true);
		}
		foreach ($logonoffnum as $key => $value){
			$login = 0;
			$logout = 0;
			$logerr = 0;
		
			if(isset($logerrs[$key])){
				$logerr = $logerrs[$key];
			}
			if(isset($value[0]))
				$logerr += $value[0];
			if(isset($value[1]))
				$login = $value[1];
			if(isset($value[2]))
				$logout = $value[2];
			
			$this->Optuser->query("INSERT INTO temppsoptusers VALUES(null,'{$this->Lv->spec_char_dbm($key)}', {$login}, {$logout}, {$logerr});");
		}		
		$this->addModel("Temp");
		$this->Temp->useTable = "temppsoptusers";
		$order_now = "Temp.name";
		$condition = array("1=1");
		list($order,$limit,$page) = $this->Pagination->init($condition, null, array('ajaxDivUpdate'=>'search', 'url'=>'/oper_evtusers/search', 'modelClass'=>'Temp', 'queryType' => array('function' => 'findByAsso'), 'sortBy' => $this->Lv->sortBy($order_now)));
		$data = $this->Temp->findByAsso($condition, array("Temp.name as Temp__name,Temp.login as Temp__login,Temp.logout as Temp__logout,Temp.logerr as Temp__logerr"),$order,$limit,$page);
		empty($data)? $data=array():$data;
		$this->set('data',$data);
		if($type=='csv'){
			$all_data = $this->Temp->findByAsso($condition, array("Temp.name as Temp__name,Temp.login as Temp__login,Temp.logout as Temp__logout,Temp.logerr as Temp__logerr"),$order,null,null);
			$this->csvdown($criteria,$all_data,2);exit;
		}
		$this->render('pc_wasay');
	}
	
	function pcgraph(& $criteria,$type=null,$by_dt=null)
	{
		$interval = $this->getInterval();
		$this->layout='ajax';
		if($this->data['Optuser']['group']=='0' || empty($this->data['Optuser']['group']))
		{
			$own_user_id = $this->_getUserGroup();
			$criteria[]=$this->getgrpid($own_user_id);
		}else
		{
			$criteria[]=$this->getgrpid($this->data['Optuser']['group']);
		}
		$criteria['GROUP BY']="Host.host_name";
		
		$asso = array(
			'Host : hosts' => array('Hstactivelog.host_id = Host.id'),
			'Rlthstgrp : rlthstgrps' => array('Hstactivelog.host_id = Rlthstgrp.host_id'),
		);
		$order_now="Hstactivelog.account";
		$fields = array(
			"Host.host_name as Temp__name",
			"sum(case when Hstactivelog.start is not null then 1 else 0 end) as Temp__login",
			"sum(case when Hstactivelog.stop is not null then 1 else 0 end) as Temp__logout",
			"sum(case when Hstactivelog.stop is null and TIMESTAMPDIFF(SECOND, Hstactivelog.active, now()) > ".$interval." then 1 else 0 end) as Temp__logerr",
			"sum(
				case when Hstactivelog.stop is null then TIMESTAMPDIFF(MINUTE, Hstactivelog.start,Hstactivelog.active) 
				else TIMESTAMPDIFF(MINUTE, Hstactivelog.start,Hstactivelog.stop) end
				) as Temp__used_time"
		);
		if($type=='csv'){
			$all_data = $this->Hstactivelog->findByAsso($criteria, $fields,$order_now,null,null,$asso);
			$this->csvdown($criteria,$all_data,7);exit;
		}
		list($order,$limit,$page) = $this->Pagination->init($criteria, null, array('ajaxDivUpdate'=>'search', 'url'=>'/oper_evtusers/search', 'modelClass'=>'Hstactivelog', 'queryType' => array('function' => 'findByAsso', 'asso' => $asso), 'sortBy' => $this->Lv->sortBy($order_now)));
		$data = $this->Hstactivelog->findByAsso($criteria, $fields,
									$order,$limit,$page,$asso);
		$this->set('data',$data);
		
		$total=0;
		foreach ($data as $da)
		{
			$total+=$da['Temp']['login'];
			$total+=$da['Temp']['logout'];
			$total+=$da['Temp']['logerr'];
		}
		$this->set('total',$total);

		if($type!='csv'){
			$keys = Set::extract($data, '{n}.Temp.name');
			$vals = Set::extract($data, '{n}.Temp.used_time');
			$this->Session->write("graphxdata",$keys);
			$this->Session->write("graphydata",$vals);
			//$this->Session->write("graphxdata",array_keys($times));
			//$this->Session->write("graphydata",array_values($times));
			$this->Session->write("graphtitle", __('pc_use_time',true));
		}
		$this->render('pcgraph');
	}
	//コンピュータ名毎に表示する  1ページ目
	function pcgraph_old(& $criteria,$type=null,$by_dt=null)
	{
		$this->layout='ajax';
		if($this->data['Optuser']['group']=='0' || empty($this->data['Optuser']['group']))
		{
			$own_user_id = $this->_getUserGroup();
			$criteria[]=$this->getgrpid($own_user_id);
		}else
		{
			$criteria[]=$this->getgrpid($this->data['Optuser']['group']);
		}
		$criteria3 = $criteria;
		$criteria[]="Optuser.log_status in (1,2)";
		$criteria[]="Optuser.AccessFrom = ''";
		$criteria['GROUP BY']="Host.host_name,Optuser.log_status";
		$order_all="Host.host_name";
		$asso = array('Host : hosts' => array('Optuser.host_id = Host.id'),
		'Rlthstgrp : rlthstgrps' => array('Optuser.host_id = Rlthstgrp.host_id'),
		);
		
		$fld = array(
			"Host.host_name as Host__host_name",
			"Optuser.log_status as Optuser__log_status",
			"count(Optuser.log_status) as Optuser__con"
		);
		
		//ホストのステータスごとに集計
		$opts = $this->Optuser->findByAsso($criteria, $fld,$order_all,null,null,$asso);
		//var_dump($opts);
		//host毎の切断回数をだすwasay
		$logerrs =  $this->GetDisconnect($criteria3,$asso,'host',$by_dt);//var_dump($logerrs);
		$logonoffnum = array();
		for ($i=0;$i<count($opts);$i++){
			$name = strtolower($opts[$i]['Host']['host_name']);
			$logonoffnum[$name][$opts[$i]['Optuser']['log_status']] = $opts[$i]['Optuser']['con'];
		}//var_dump ($logonoffnum);
		
		//接続時間
		$crit = $criteria3;
		$crit[]="Optuser.log_status = 1";
		$crit[]="Optuser.AccessFrom = ''";
		$crit[]="Optuser3.tslog is null";
		$crit['GROUP BY']="Host.host_name";
		$assos = array(
			'Host : hosts' => array('Optuser.host_id = Host.id'),
			'Rlthstgrp : rlthstgrps' => array('Optuser.host_id = Rlthstgrp.host_id'),
			'Optuser2 : optusers' => array(
				'Optuser.host_id = Optuser2.host_id',
				'Optuser.LogonID = Optuser2.LogonID',
				'Optuser.tslog < Optuser2.tslog',
				'Optuser2.log_status in (0, 2) ',),
			'Optuser3 : optusers : left' => array(
				'Optuser.host_id = Optuser3.host_id',
				'Optuser.account = Optuser3.account',
				'Optuser.tslog < Optuser3.tslog',
				'Optuser3.tslog < Optuser2.tslog',
				'Optuser3.log_status = 1 ',),
		);
		$field = array(
			"lower(Host.host_name) as Host__host_name",
			"sum(UNIX_TIMESTAMP(Optuser2.tslog) - UNIX_TIMESTAMP(Optuser.tslog))/60 as Optuser__minutes",
		);
		$times =array();
		$tmp_times = $this->Optuser->findByAsso($crit, $field, "Host.host_name",null,null,$assos);
		if(!empty($tmp_times)){
			$keys = Set::extract($tmp_times, '{n}.Host.host_name');
			$vals = Set::extract($tmp_times, '{n}.Optuser.minutes');
			$times = array_combine($keys, $vals);
		}

		/*$times_add =  $this->GetDisconnectTime($criteria3,$asso,'host',$by_dt);//var_dump($logerrs);
		foreach($times_add as $k => $t){
			if(isset($times[$k]))
				$times[$k] += $t;
		}*/
		//var_dump($times_add);
		
		$result = $this->Optuser->query('CREATE TEMPORARY TABLE temppsoptusers (id serial, name  varchar(127), login integer,logout integer,logerr integer,used_time integer)');
		if($result === false){
			debug("CREATE TEMPORARY TABLE failed!", true);
		}
		foreach ($logonoffnum as $key => $value){
			$login = 0;
			$logout = 0;
			$logerr = 0;
		
			if(isset($logerrs[$key])){
				$logerr = $logerrs[$key];
			}
			if(isset($value[0]))
				$logerr += $value[0];
			if(isset($value[1]))
				$login = $value[1];
			if(isset($value[2]))
				$logout = $value[2];
			
			$minutes = 0;
			if(isset($times[$key]))
				$minutes = $times[$key];
			
			$this->Optuser->query("INSERT INTO temppsoptusers VALUES(null,'{$this->Lv->spec_char_dbm($key)}', {$login}, {$logout}, {$logerr}, {$minutes});");
		}		
		$this->addModel("Temp");
		$this->Temp->useTable = "temppsoptusers";
		$order_now = "Temp.name";
		$condition = array("1=1");
		list($order,$limit,$page) = $this->Pagination->init($condition, null, array('ajaxDivUpdate'=>'search', 'url'=>'/oper_evtusers/search', 'modelClass'=>'Temp', 'queryType' => array('function' => 'findByAsso'), 'sortBy' => $this->Lv->sortBy($order_now)));
		$data = $this->Temp->findByAsso($condition, array("Temp.name as Temp__name,Temp.login as Temp__login,Temp.logout as Temp__logout,Temp.logerr as Temp__logerr,Temp.used_time as Temp__used_time"),$order,$limit,$page);
		empty($data)? $data=array():$data;
		$this->set('data',$data);
		if($type=='csv'){
			$all_data = $this->Temp->findByAsso($condition, array("Temp.name as Temp__name,Temp.login as Temp__login,Temp.logout as Temp__logout,Temp.logerr as Temp__logerr,Temp.used_time as Temp__used_time"),$order,null,null);
			$this->csvdown($criteria,$all_data,7);exit;
		}else{
			$keys = Set::extract($data, '{n}.Temp.name');
			$vals = Set::extract($data, '{n}.Temp.used_time');
			$this->Session->write("graphxdata",$keys);
			$this->Session->write("graphydata",$vals);
			//$this->Session->write("graphxdata",array_keys($times));
			//$this->Session->write("graphydata",array_values($times));
			$this->Session->write("graphtitle", __('pc_use_time',true));
		}
		$this->render('pcgraph');
	}
	
	function graph($time)
	{  
		$this->layout='ajax';
	}
	
	function graphimg($time)
	{   
		$this->layout='ajax';
		
		$xdata = $this->Session->read("graphxdata");
		$ydata = $this->Session->read("graphydata");
		$title = $this->Session->read("graphtitle");
		$width = count($xdata)*30+85;
		
		include ("../jpgraph/jpgraph.php");
		include ("../jpgraph/jpgraph_bar.php");

		//setlocale (LC_ALL, 'et_EE.ISO-8859-1');
		$graph = new Graph(750, $width, "auto"); 
		$graph->SetFrame(false);
		$graph->SetScale("textlin");
		$graph->title->SetMargin(20);
		$graph->title->Set($title);
        $graph->title->SetFont(FF_GOTHIC,FS_NORMAL);
		
		$graph->Set90AndMargin(150,0,50,35);
		$graph->xaxis->SetFont(FF_GOTHIC,FS_NORMAL);
		$graph->xaxis->SetTickLabels($xdata);
		$graph->yaxis->SetPos("max");
		$graph->yaxis->SetLabelMargin(-25); 
		
		$barplot = new BarPlot($ydata);
		$barplot->SetWidth(0.6);
		$barplot->SetColor("skyblue");
		$barplot->SetFillColor("skyblue");
		
		
		$graph->Add($barplot);

		$graph->Stroke();
	}
	
	function acdate(& $criteria,$acpc=null,$type=null,$by_dt=null)
	{
		$interval = $this->getInterval();
		$this->set('back',$criteria);
		$this->layout='ajax';
		if($this->data['Optuser']['group']=='0' || empty($this->data['Optuser']['group']))
		{
			$own_user_id = $this->_getUserGroup();
			$criteria[]=$this->getgrpid($own_user_id);
		}else
		{
			$criteria[]=$this->getgrpid($this->data['Optuser']['group']);
		}
		$criteria['GROUP BY']="DATEPART(Hstactivelog.start)";
		
		$asso = array(
			'Host : hosts' => array('Hstactivelog.host_id = Host.id'),
			'Rlthstgrp : rlthstgrps' => array('Hstactivelog.host_id = Rlthstgrp.host_id'),
		);
		$order_now="Temp__name";
		$fields = array(
			"DATEPART(Hstactivelog.start) as Temp__name",
			"sum(case when Hstactivelog.start is not null then 1 else 0 end) as Temp__login",
			"sum(case when Hstactivelog.stop is not null then 1 else 0 end) as Temp__logout",
			"sum(case when Hstactivelog.stop is null and TIMESTAMPDIFF(SECOND, Hstactivelog.active, now()) > ".$interval." then 1 else 0 end) as Temp__logerr",
			"sum(case when Hstactivelog.stop is not null then TIMESTAMPDIFF(SECOND, Hstactivelog.start,Hstactivelog.stop) else 0 end) as Temp__used_time"
		);
		if($type=='csv'){
			$all_data = $this->Hstactivelog->findByAsso($criteria, $fields, $order_now,null,null,$asso);
			$this->csvdown($criteria,$all_data,3);exit;
		}
		list($order,$limit,$page) = $this->Pagination->init($criteria, null, array('ajaxDivUpdate'=>'search', 'url'=>'/oper_evtusers/search/1/'.$acpc, 'modelClass'=>'Hstactivelog', 'queryType' => array('function' => 'findByAsso', 'asso' => $asso), 'sortBy' => $this->Lv->sortBy($order_now)));
		$data = $this->Hstactivelog->findByAsso($criteria, $fields,
									$order,$limit,$page,$asso);
		$this->set('data',$data);
		
		$this->set('acpc',$acpc);

		$this->render('acdate_wasay');
	}
	//ログオンアカウント毎に表示する 2ページ目
	//テーブルのログオンアカウント名をクリックした後
	function acdate_old(& $criteria,$acpc=null,$type=null,$by_dt=null)
	{

		$this->layout='ajax';
		$this->set('back',$criteria);

		if($this->data['Optuser']['group']=='0' || empty($this->data['Optuser']['group']))
		{
			$own_user_id = $this->_getUserGroup();
			$criteria[]=$this->getgrpid($own_user_id);
		}else
		{
			$criteria[]=$this->getgrpid($this->data['Optuser']['group']);
		}	
		$criteria3 = $criteria;
		$criteria[]=" Optuser.log_status in (1,2)";
		$criteria[]=" Optuser.account <> '' ";
		$criteria['GROUP BY']="Optuser.log_status,DATE(tslog),Optuser.AccessFrom";
		
		$order_all="DATEPART(tslog)";
		$asso = array('Host : hosts' => array('Optuser.host_id = Host.id'),
		'Rlthstgrp : rlthstgrps' => array('Optuser.host_id = Rlthstgrp.host_id'),
		);
		$opts = $this->Optuser->findByAsso($criteria, array("DATEPART(tslog) as Optuser__date,Optuser.log_status as Optuser__log_status,count(Optuser.log_status) as Optuser__con,TIMEPART(tslog) as Optuser__time,Optuser.AccessFrom as Optuser__AccessFrom, Optuser.LogonID as Optuser__LogonID"),$order_all,null,null,$asso);

		//debug($opts);echo count($opts);
		
		//debug($criteria);
		//追加するオフの時間を取得 acc
		$logerrs = $this->GetDisconnect3($criteria3,$asso,"account",$by_dt);
		//debug($logerrs);echo count($logerrs);
		//debug($opts);

		$tmp = array();
		for ($i=0;$i<count($opts);$i++)
		{
			$tmp[] = $opts[$i];
			for ($j=0;$j<count($logerrs);$j++)
			{
				if($opts[$i]['Optuser']['date'] == $logerrs[$j]['Optuser']['date']){
					//array_splice($opts, $j, 0, $logerrs[$i]);
					$tmp[] = $logerrs[$j];
					$logerrs[$j]['Optuser']['date'] = 0;
				}
			}
		}
		//debug($tmp);

$opts = $tmp;
		
		$date=$opts[0]['Optuser']['date'];
		$array_temp=array();//$logerrs;
		$j=0;
		for ($i=0;$i<count($opts);$i++)
		{
			if ($date==$opts[$i]['Optuser']['date'])
			{
				$array_temp[$j][]=$opts[$i];
			}
			else
			{
				$date=$opts[$i]['Optuser']['date'];
				$i--;
				$j++;
			}
		}//debug($array_temp);
		
		$result = $this->Optuser->query('CREATE TEMPORARY TABLE temppsoptusers (id serial, name date, login integer,logout integer,logerr integer,used_time time)');
		if($result === false){
			debug("CREATE TEMPORARY TABLE failed!", true);
		}
		foreach($array_temp as $v){
			unset($login);
			unset($logout);
			unset($logerr);
			foreach ($v as $pass_log){
				if ($pass_log['Optuser']['log_status']==1){
					$login = $login+$pass_log['Optuser']['con'];
				}
				elseif($pass_log['Optuser']['log_status']==2){
					$logout = $logout+$pass_log['Optuser']['con'];
				}
				elseif($pass_log['Optuser']['log_status']==0){
					$logerr = $logerr+$pass_log['Optuser']['con'];
				}
			}
			isset($login)?null:$login = 0;
			isset($logout)?null:$logout = 0;
			isset($logerr)?null:$logerr = 0;
			$shu = 0;
			$lytime = '00:00:00';
/*
			$criteria1=$criteria;
			$criteria1[]= "Optuser.tslog BETWEEN '{$v[0]['Optuser']['date']}' and '{$v[0]['Optuser']['date']}' + INTERVAL 1 DAY - INTERVAL 1 MICROSECOND";
			$criteria1['GROUP BY']= "Optuser__date";
			$used_time = $this->Optuser->findByAsso($criteria1, array('DATE(tslog) as Optuser__date, Optuser.log_status as Optuser__log_status,TIMEPART(tslog) as Optuser__time'), null, null, null, $asso);
			//debug($used_time);
			foreach ($used_time as $value){//echo $value['Optuser']['log_status']."-".$value['Optuser']['time']."-".$value['Optuser']['AccessFrom']."-".$shu."</br>";
				//logon
				if($value['Optuser']['log_status'] == 1 && empty($value['Optuser']['AccessFrom'])){
					$shu = $shu-strtotime($value['Optuser']['time']);
				}
				elseif(empty($value['Optuser']['AccessFrom'])){
					$shu = $shu+strtotime($value['Optuser']['time']);
				}
				//echo $value['Optuser']['log_status']."--".$value['Optuser']['time']."<br/>";
			}
			*/
			foreach ($v as $pass_log){
				//logon
				if($pass_log['Optuser']['log_status'] == 1 && empty($pass_log['Optuser']['AccessFrom'])){
					$shu = $shu-strtotime($pass_log['Optuser']['time']);
				}
				elseif(empty($pass_log['Optuser']['AccessFrom'])){
					$shu = $shu+strtotime($pass_log['Optuser']['time']);
				}
			}
			if($shu < 0){
				if(date('Y-m-d') == $v[0]['Optuser']['date'])
				{
					$shu = $shu+strtotime(date("H:i:s"));
				}
				else{
					$shu = 86399+$shu;
					$shu=$shu+1185894000;
				}
			}
			if($shu<11858940){
				$shu=$shu+1185894000;
			}
			$lytime = date("H:i:s",$shu);
			$this->Optuser->query("INSERT INTO temppsoptusers VALUES(null,'{$v[0]['Optuser']['date']}', {$login}, {$logout}, {$logerr}, '{$lytime}');");
		}
		$this->addModel("Temp");
		$this->Temp->useTable = "temppsoptusers";
		$order_now = "Temp.name";
		$condition = array("1=1");
		list($order,$limit,$page) = $this->Pagination->init($condition, null, array('ajaxDivUpdate'=>'search', 'url'=>'/oper_evtusers/search/1/'.$acpc, 'modelClass'=>'Temp', 'queryType' => array('function' => 'findByAsso'), 'sortBy' => $this->Lv->sortBy($order_now)));
		$data = $this->Temp->findByAsso($condition, array("Temp.name as Temp__name,Temp.login as Temp__login,Temp.logout as Temp__logout,Temp.logerr as Temp__logerr,Temp.used_time as Temp__used_time"),$order,$limit,$page);
		empty($data)? $data=array():$data;
		$this->set('data',$data);
		$this->set('acpc',$acpc);
		$this->set('data',$data);
		if($type=='csv'){
			$all_data = $this->Temp->findByAsso($condition, array("Temp.name as Temp__name,Temp.login as Temp__login,Temp.logout as Temp__logout,Temp.logerr as Temp__logerr,Temp.used_time as Temp__used_time"),$order,null,null);
			$this->csvdown($criteria,$all_data,3);exit;
		}
		$this->render('acdate_wasay');
	}
	//コンピュータ名毎に表示する 2ページ目
	function pcdate(& $criteria,$acpc=null,$type=null)
	{
		$interval = $this->getInterval();
		$this->set('back',$criteria);
		$this->layout='ajax';
		if($this->data['Optuser']['group']=='0' || empty($this->data['Optuser']['group']))
		{
			$own_user_id = $this->_getUserGroup();
			$criteria[]=$this->getgrpid($own_user_id);
		}else
		{
			$criteria[]=$this->getgrpid($this->data['Optuser']['group']);
		}
		$criteria['GROUP BY']="DATEPART(Hstactivelog.start)";
		
		$asso = array(
			'Host : hosts' => array('Hstactivelog.host_id = Host.id'),
			'Rlthstgrp : rlthstgrps' => array('Hstactivelog.host_id = Rlthstgrp.host_id'),
		);
		$order_now="Temp__name";
		$fields = array(
			"DATEPART(Hstactivelog.start) as Temp__name",
			"sum(case when Hstactivelog.start is not null then 1 else 0 end) as Temp__login",
			"sum(case when Hstactivelog.stop is not null then 1 else 0 end) as Temp__logout",
			"sum(case when Hstactivelog.stop is null and TIMESTAMPDIFF(SECOND, Hstactivelog.active, now()) > ".$interval." then 1 else 0 end) as Temp__logerr",
			"sum(case when Hstactivelog.stop is not null then TIMESTAMPDIFF(SECOND, Hstactivelog.start,Hstactivelog.stop) else 0 end) as Temp__used_time"
		);
		if($type=='csv'){
			$all_data = $this->Hstactivelog->findByAsso($criteria, $fields,$order_now,null,null,$asso);
			$this->csvdown($criteria,$all_data,4);exit;
		}
		list($order,$limit,$page) = $this->Pagination->init($criteria, null, array('ajaxDivUpdate'=>'search', 'url'=>'/oper_evtusers/search/2/'.$acpc, 'modelClass'=>'Hstactivelog', 'queryType' => array('function' => 'findByAsso', 'asso' => $asso), 'sortBy' => $this->Lv->sortBy($order_now)));
		$data = $this->Hstactivelog->findByAsso($criteria, $fields,
									$order,$limit,$page,$asso);
		$this->set('data',$data);
		
		$this->set('acpc',$acpc);

		$this->render('pcdate_wasay');
	}
	function pcdate_old(& $criteria,$acpc=null,$type=null)
	{
		$this->layout='ajax';

		$result = $this->Optuser->query('CREATE TEMPORARY TABLE temppsoptusers (id serial, name date, login integer,logout integer,logerr integer,used_time time)');
		if($result === false){
			debug("CREATE TEMPORARY TABLE failed!", true);
		}



		if($this->data['Optuser']['group']=='0' || empty($this->data['Optuser']['group']))
		{
			$own_user_id = $this->_getUserGroup();
			$criteria[]=$this->getgrpid($own_user_id);
		}else
		{
			$criteria[]=$this->getgrpid($this->data['Optuser']['group']);
		}	$criteria3 = $criteria;
		
		$criteria[]=" Optuser.log_status in (0,1,2)";
		$criteria[]=" Optuser.account <> '' ";
		$criteria['GROUP BY']="Optuser.log_status,DATE(tslog),Optuser.AccessFrom";

		$order_all="DATEPART(tslog)";
		$asso = array('Host : hosts' => array('Optuser.host_id = Host.id'),
		'Rlthstgrp : rlthstgrps' => array('Optuser.host_id = Rlthstgrp.host_id'),
		);
		$opts = $this->Optuser->findByAsso($criteria, array("DATEPART(tslog) as Optuser__date,Optuser.log_status as Optuser__log_status,count(Optuser.log_status) as Optuser__con,TIMEPART(tslog) as Optuser__time,Optuser.AccessFrom as Optuser__AccessFrom"),$order_all,null,null,$asso);
		
		//追加するオフの時間を取得 host
		$logerrs = $this->GetDisconnect2($criteria3,$asso);
		debug($logerrs);

		for ($i=0;$i<count($logerrs);$i++)
		{
			for ($j=0;$j<count($opts);$j++)
			{
				if($opts[$j]['Optuser']['date'] == $logerrs[$i][0]['Optuser']['date']){
					array_splice($opts, $j, 0, $logerrs[$i]);break;
				}
			}
		}
		//debug($opts);

		
		
		$date=$opts[0]['Optuser']['date'];
		$array_temp=array();
		$j=0;
		for ($i=0;$i<count($opts);$i++)
		{
			if ($date==$opts[$i]['Optuser']['date'])
			{
				$array_temp[$j][]=$opts[$i];
			}
			else
			{
				$date=$opts[$i]['Optuser']['date'];
				$i--;
				$j++;
			}
		}
debug($array_temp);
		foreach($array_temp as $v){
			unset($login);
			unset($logout);
			unset($logerr);
			foreach ($v as $pass_log){
				if ($pass_log['Optuser']['log_status']==1){
					$login = $login+$pass_log['Optuser']['con'];
				}
				elseif($pass_log['Optuser']['log_status']==2){
					$logout = $logout+$pass_log['Optuser']['con'];
				}
				elseif($pass_log['Optuser']['log_status']==0){
					$logerr = $logerr+$pass_log['Optuser']['con'];
				}
			}
			isset($login)?null:$login = 0;
			isset($logout)?null:$logout = 0;
			isset($logerr)?null:$logerr = 0;
			$shu = 0;
			$lytime = '00:00:00';
/*
			$criteria1=$criteria;
			$criteria1[]= "Optuser.tslog BETWEEN '{$v[0]['Optuser']['date']}' and '{$v[0]['Optuser']['date']}' + INTERVAL 1 DAY - INTERVAL 1 MICROSECOND";
			$criteria1['GROUP BY']= "Optuser__date";
			$used_time = $this->Optuser->findByAsso($criteria1, array('DATE(tslog) as Optuser__date, Optuser.log_status as Optuser__log_status,TIMEPART(tslog) as Optuser__time'), null, null, null, $asso);
			
			foreach ($used_time as $value){
				if($value['Optuser']['log_status'] == 1 && empty($value['Optuser']['AccessFrom'])){
					$shu = $shu-strtotime($value['Optuser']['time']);
				}
				elseif(empty($value['Optuser']['AccessFrom'])){
					$shu = $shu+strtotime($value['Optuser']['time']);
				}
			}
*/
			foreach ($v as $pass_log){
				if($pass_log['Optuser']['log_status'] == 1 && empty($pass_log['Optuser']['AccessFrom'])){
					$shu = $shu-strtotime($pass_log['Optuser']['time']);
				}
				elseif(empty($pass_log['Optuser']['AccessFrom'])){
					$shu = $shu+strtotime($pass_log['Optuser']['time']);
				}
			}
			if($shu < 0){
				if(date('Y-m-d') == $v[0]['Optuser']['date'])
				{
					$shu = $shu+strtotime(date("H:i:s"));
				}
				else{
					$shu = 86399+$shu;
					$shu=$shu+1185894000;
				}
			}
			if($shu<11858940){
				$shu=$shu+1185894000;
			}
			$lytime = date("H:i:s",$shu);
			$this->Optuser->query("INSERT INTO temppsoptusers VALUES(null,'{$v[0]['Optuser']['date']}', {$login}, {$logout}, {$logerr}, '{$lytime}');");
		}
		$this->addModel("Temp");
		$this->Temp->useTable = "temppsoptusers";
		$order_now = "Temp.name";
		$condition = array("1=1");
		list($order,$limit,$page) = $this->Pagination->init($condition, null, array('ajaxDivUpdate'=>'search', 'url'=>'/oper_evtusers/search/2/'.$acpc, 'modelClass'=>'Temp', 'queryType' => array('function' => 'findByAsso'), 'sortBy' => $this->Lv->sortBy($order_now)));
		$data = $this->Temp->findByAsso($condition, array("Temp.name as Temp__name,Temp.login as Temp__login,Temp.logout as Temp__logout,Temp.logerr as Temp__logerr,Temp.used_time as Temp__used_time"),$order,$limit,$page);
		empty($data)? $data=array():$data;
		$this->set('data',$data);
		$this->set('acpc',$acpc);
		$this->set('data',$data);
		if($type=='csv'){
			$all_data = $this->Temp->findByAsso($condition, array("Temp.name as Temp__name,Temp.login as Temp__login,Temp.logout as Temp__logout,Temp.logerr as Temp__logerr,Temp.used_time as Temp__used_time"),$order,null,null);
			$this->csvdown($criteria,$all_data,4);exit;
		}
		$this->render('pcdate_wasay');
	}
	
	//3ページ目
	function detail(& $criteria,$acpc=null,$tim=null,$judg=null,$type=null)
	{
		$interval = $this->getInterval();
		$crit_date = array();
		$this->layout='ajax';
		$time = $tim;
		if ($tim == 1){
			$tmp = "DATEPART(Hstactivelog.start) = '{$this->data['dt_check']['start_year']}-{$this->data['dt_check']['start_month']}-{$this->data['dt_check']['start_day']}' ";
			$criteria[] = $tmp;
			$crit_date[] = $tmp;
			$time = "{$this->data['dt_check']['start_year']}-{$this->data['dt_check']['start_month']}-{$this->data['dt_check']['start_day']}";
		}
		$criteria_org = $criteria;
		for($i = 0; $i < count($criteria); $i++){
			//temppsoptusersに入れるときに$timeで指定されるので不要
			//時間帯指定は残す
			$timepart = strpos($criteria[$i],"TIMEPART(Hstactivelog.start)");
			if($timepart !== false){
				$criteria[$i] = substr($criteria[$i], $timepart);
				if(strpos($criteria[$i],"Hstactivelog.start") !== false)
					$criteria[$i] = str_replace("Hstactivelog.start","Optuser.tslog",$criteria[$i]);
			}
			if(strpos($criteria[$i],"Hstactivelog.start BETWEEN") !== false)
				$criteria[$i] = "5=5";
			if(strpos($criteria[$i],"DATEPART(Hstactivelog.start)") !== false)
				$criteria[$i] = "3=3";
			
			if(strpos($criteria[$i],"Hstactivelog.account") !== false)
				$criteria[$i] = str_replace("Hstactivelog.account","Optuser.account",$criteria[$i]);
		}		
		//var_dump($criteria);
		//一時的にテーブルを変える
		$result = $this->Optuser->query('drop TEMPORARY table if exists temppsoptusers');
		$result = $this->Optuser->query('CREATE TEMPORARY TABLE temppsoptusers like optusers');
		if($result === false){
			debug("CREATE TEMPORARY TABLE failed!", true);
		}
		$oldtable = $this->Optuser->useTable;
		$this->Optuser->useTable = "temppsoptusers";
		$this->Optuser->query("insert into temppsoptusers(host_id,account,log_status,tslog,reason,AccessFrom) select host_id,account,1,start,'','' from hstactivelogs where start BETWEEN '$time' and '$time' + INTERVAL 1 DAY - INTERVAL 1 MICROSECOND group by host_id,account,start");
		$this->Optuser->query("insert into temppsoptusers(host_id,account,log_status,tslog,reason,AccessFrom) select host_id,account,case when stop is null then 100 else 2 end,case when stop is null then active else stop end,'','' from hstactivelogs where start BETWEEN '$time' and '$time' + INTERVAL 1 DAY - INTERVAL 1 MICROSECOND and TIMESTAMPDIFF(SECOND, active, now()) > ".$interval." group by host_id,account,start");

		$asso = array('Host : hosts' => array('Optuser.host_id = Host.id'),
		'Rlthstgrp : rlthstgrps' => array('Optuser.host_id = Rlthstgrp.host_id'),
		'Group : groups' => array('Group.id = Rlthstgrp.group_id'),
		'Grpauth : grpauths' => array('Group.id = Grpauth.group_id'),
		);
		$order_now = 'Optuser.tslog, Optuser.log_status';
		$criteria_grp = $criteria;
		$criteria_grp['GROUP BY'] = "Optuser.tslog, Optuser.host_id, Optuser.account";
		if($type=='csv'){
			$all_data = $this->Optuser->findByAsso($criteria_grp, 
				array('Optuser.tslog as Optuser__tslog,Group.group_name as Group__group_name,Host.host_name as Host__host_name,Optuser.account as Optuser__account,Optuser.log_status as Optuser__log_status,Optuser.reason as Optuser__reason,Optuser.AccessFrom as Optuser__AccessFrom'), 
				$order_now, null, null, $asso);
			$this->csvdown($criteria_grp,$all_data,5);exit;
		}
		list($order,$limit,$page) = $this->Pagination->init($criteria_grp, null, array('ajaxDivUpdate'=>'search', 'url'=>'/oper_evtusers/search/'.$judg."/".$this->Lv->url_param_encode2($acpc)."/".$tim, 'modelClass'=>'Optuser', 'queryType' => array('function' => 'findByAsso', 'asso' => $asso), 'sortBy' => $this->Lv->sortBy($order_now)));
		$data = $this->Optuser->findByAsso($criteria_grp, 
			array('Optuser.tslog as Optuser__tslog,Group.group_name as Group__group_name,Host.host_name as Host__host_name,Optuser.account as Optuser__account,Optuser.log_status as Optuser__log_status,Optuser.reason as Optuser__reason,Optuser.AccessFrom as Optuser__AccessFrom'), 
			$order, $limit, $page, $asso);
		empty($data)? $data=array():$data;
		
		$this->set('data',$data);
		$this->set('judg',$judg);
		$this->set('acpc',$acpc);
		$this->set('tim',$tim);
		//利用テーブルを戻す
		$this->Optuser->useTable = $oldtable;
	//	$criteria = $criteria_org;
		$this->render('detail_wasay');
	}
	function detail_old(& $criteria,$acpc=null,$tim=null,$judg=null,$type=null)
	{
		$crit_date = array();
		$this->layout='ajax';
		$time = $tim;
		if ($tim == 1){
			$tmp = "DATEPART(Optuser.tslog) = '{$this->data['dt_check']['start_year']}-{$this->data['dt_check']['start_month']}-{$this->data['dt_check']['start_day']}' ";
			$criteria[] = $tmp;
			$crit_date[] = $tmp;
			$time = "{$this->data['dt_check']['start_year']}-{$this->data['dt_check']['start_month']}-{$this->data['dt_check']['start_day']}";
		}
		
		$asso = array('Host : hosts' => array('Optuser.host_id = Host.id'),
		'Rlthstgrp : rlthstgrps' => array('Optuser.host_id = Rlthstgrp.host_id'),
		'Group : groups' => array('Group.id = Rlthstgrp.group_id'),
		'Grpauth : grpauths' => array('Group.id = Grpauth.group_id'),
		);
		
		$criteria3 = $criteria;
		//追加するオフの時間を取得 
		$logerrs = $this->GetDisconnect2($criteria3,$asso,$crit_date);		
		//一時的にテーブルを変える
		$result = $this->Optuser->query('CREATE TEMPORARY TABLE temppsoptusers like optusers');
		if($result === false){
			debug("CREATE TEMPORARY TABLE failed!", true);
		}

		$this->Optuser->query("insert into temppsoptusers select * from optusers where tslog BETWEEN '$time' and '$time' + INTERVAL 1 DAY - INTERVAL 1 MICROSECOND and log_status in (0,1,2)");

		$oldtable = $this->Optuser->useTable;
		$this->Optuser->useTable = "temppsoptusers";


		
		$criteria[]="Optuser.log_status in (0,1,2)";
		$criteria[]="Optuser.account <> '' ";
		if($this->data['Optuser']['group']=='0' || empty($this->data['Optuser']['group']))
		{
			$own_user_id = $this->_getUserGroup();
			$criteria[]=" Grpauth.org_grp_id = $own_user_id ";
		}else
		{
			$criteria[]=" Grpauth.org_grp_id=".$this->data['Optuser']['group']." ";
		}


		

		foreach($logerrs as $value)
		{
			$host_id = $value[0]['Optuser']['host_id'];
			$account = $value[0]['Optuser']['account'];
			$log_status = $value[0]['Optuser']['log_status'];
			$tslog = $value[0]['Optuser']['tslog'];
			$LogonID = $value[0]['Optuser']['LogonID'];
			$AccessFrom = $value[0]['Optuser']['AccessFrom'];
			$this->Optuser->query("insert into temppsoptusers(host_id,account,log_status,tslog,LogonID,AccessFrom) values({$host_id},'{$account}',{$log_status},'{$tslog}','{$LogonID}','{$AccessFrom}')");
		}
		
		
		list($order,$limit,$page) = $this->Pagination->init($criteria, null, array('ajaxDivUpdate'=>'search', 'url'=>'/oper_evtusers/search/'.$judg."/".$acpc."/".$tim, 'modelClass'=>'Optuser', 'queryType' => array('function' => 'findByAsso', 'asso' => $asso), 'sortBy' => $this->Lv->sortBy('Optuser.id, Optuser.tslog, Optuser.log_status')));
		$data = $this->Optuser->findByAsso($criteria, array('Optuser.tslog as Optuser__tslog,Group.group_name as Group__group_name,Host.host_name as Host__host_name,Optuser.account as Optuser__account,Optuser.log_status as Optuser__log_status,Optuser.reason as Optuser__reason,Optuser.AccessFrom as Optuser__AccessFrom'), $order, $limit, $page, $asso);
		empty($data)? $data=array():$data;
		$this->set('data',$data);
		$this->set('judg',$judg);
		$this->set('acpc',$acpc);
		$this->set('tim',$tim);
		if($type=='csv'){
			$all_data = $this->Optuser->findByAsso($criteria, array('Optuser.tslog as Optuser__tslog,Group.group_name as Group__group_name,Host.host_name as Host__host_name,Optuser.account as Optuser__account,Optuser.log_status as Optuser__log_status,Optuser.reason as Optuser__reason,Optuser.AccessFrom as Optuser__AccessFrom'), $order, null, null, $asso);
			$this->csvdown($criteria,$all_data,5);exit;
		}
				//利用テーブルを戻す
		$this->Optuser->useTable = $oldtable;
		$this->render('detail_wasay');
	}
	function groupName($group_id)
	{
		$criteria=" Group.id=".$group_id." ";
		$group_n= $this->Group->findAll($criteria);
		$group_name = $group_n[0]["Group"]["group_name"];
		return $group_name;
	}

	function csvdown($criteria=array(),$data=array(),$type=null)
	{
		require_once( 'csv/DlFactory.php' );
		if($this->data['Optuser']['group']=='0' || empty($this->data['Optuser']['group']))
		{
			$own_user_id = $this->_getUserGroup();
		}else
		{
			$own_user_id = $this->data['Optuser']['group'];
		}
		$this->data["Optuser"]["group"] = $this->groupName($own_user_id);
		if($this->data['Optuser']['account_pc']==1){
			$this->data['Optuser']['account_pc'] = __("client_view",true);
		}else{
			$this->data['Optuser']['account_pc'] = __("login_account_view",true);
		}
		if($type==1){
			$csv = DlFactory::create("oper_evtusers");
			$csv->special_cols = array(
			"Temp/name"=>__('login_account_name',$return = true),
			"Temp/login"=>__('count_login',$return = true),
			"Temp/logout"=>__('count_logout_nom_change_wasay',$return = true),
			"Temp/logerr"=>__('count_logout_err_change_wasay',$return = true),
			);
			$csv->sendCSVFile($data,$this->data,__('log_onlog_off',$return = true));
		}
		elseif($type==2){
			$csv = DlFactory::create("oper_evtusers");
			$csv->special_cols = array(
			"Temp/name"=>__('computer_name',$return = true),
			"Temp/login"=>__('count_login',$return = true),
			"Temp/logout"=>__('count_logout_nom_change_wasay',$return = true),
			"Temp/logerr"=>__('count_logout_err_change_wasay',$return = true),
			);
			$csv->sendCSVFile($data,$this->data,__('log_onlog_off',$return = true));
		}
		elseif($type==3){//アカウント2ページ目
			$csv = DlFactory::create("oper_evtusers");
			$csv->special_cols = array(
			"Temp/name"=>__('dating',$return = true),
			"Temp/login"=>__('count_login',$return = true),
			"Temp/logout"=>__('count_logout_nom_change_wasay',$return = true),
			"Temp/logerr"=>__('count_logout_err_change_wasay',$return = true),
			//"Temp/used_time"=>__('usetime',$return = true)
			);
			$csv->sendCSVFile($data,$this->data,__('log_onlog_off',$return = true));
		}
		elseif($type==4){
			$csv = DlFactory::create("oper_evtusers");
			$csv->special_cols = array(
			"Temp/name"=>__('dating',$return = true),
			"Temp/login"=>__('count_login',$return = true),
			"Temp/logout"=>__('count_logout_nom_change_wasay',$return = true),
			"Temp/logerr"=>__('count_logout_err_change_wasay',$return = true),
			//"Temp/used_time"=>__('usetime',$return = true)
			);
			$csv->sendCSVFile($data,$this->data,__('log_onlog_off',$return = true));
		}
		elseif($type==5){//3ページ目
			$csv = DlFactory::create("oper_evtusers");
			$csv->special_cols = array(
			"Optuser/tslog"=>__('dating',$return = true),
			"Group/group_name"=>__('group_name',$return = true),
			"Host/host_name"=>__('computer_name',$return = true),
			"Optuser/account"=>__('login_account_name',$return = true),
			"Optuser/log_status"=>__('status',$return = true),
			);
			$login=__("login",true);//ログオン
			$logout_status=__("logout_status",true);//ログオフ（正常?�?


			$logout_reason=__("logout_reason",true);//ログオフ�?


			$end_logout_reason=__("end_logout_reason",true);//?�?
			foreach ($data as $output){
				if($output['Optuser']['log_status'] == '1'){
					$status = $login;
				}
				elseif($output['Optuser']['log_status'] == '2'){
					$status = $logout_status;
				}
				elseif($output['Optuser']['log_status'] == '0' || $output['Optuser']['log_status'] == '100'){
					$status = $logout_reason.$output['Optuser']['reason'].$end_logout_reason;
				}
				$output_data = array(
				'Optuser' => array(
				'tslog' => $output['Optuser']['tslog'],
				'account' => strtolower($output['Optuser']['account']),
				'AccessFrom' => $output['Optuser']['AccessFrom'],
				'log_status' => $status
				),
				'Group' => array(
				'group_name' => $output['Group']['group_name'],
				),
				'Host' => array(
				'host_name' => $output['Host']['host_name'],
				)
				);
				$final_data[] = $output_data;
			}
			$csv->sendCSVFile($final_data,$this->data,__('log_onlog_off',$return = true));
		}elseif($type==6){
			$csv = DlFactory::create("oper_evtusers");
			$csv->special_cols = array(
			"Temp/name"=>__('login_account_name',$return = true),
			"Temp/login"=>__('count_login',$return = true),
			"Temp/logout"=>__('count_logout_nom_change_wasay',$return = true),
			"Temp/logerr"=>__('count_logout_err_change_wasay',$return = true),
			"Temp/used_time"=>__('use_time',$return = true),
			);
			$csv->sendCSVFile($data,$this->data,__('log_onlog_off',$return = true));
		}
		elseif($type==7){
			$csv = DlFactory::create("oper_evtusers");
			$csv->special_cols = array(
			"Temp/name"=>__('computer_name',$return = true),
			"Temp/login"=>__('count_login',$return = true),
			"Temp/logout"=>__('count_logout_nom_change_wasay',$return = true),
			"Temp/logerr"=>__('count_logout_err_change_wasay',$return = true),
			"Temp/used_time"=>__('use_time',$return = true),
			);
			$csv->sendCSVFile($data,$this->data,__('log_onlog_off',$return = true));
		}
	}

	function csvdown_detail()
	{
		$interval = $this->getInterval();
		require_once( 'csv/DlFactory.php' );
		$csv = DlFactory::create("oper_evtusers");
		if($this->data['Optuser']['group']=='0' || empty($this->data['Optuser']['group']))
		{
			$own_user_id = $this->_getUserGroup();
		}else
		{
			$own_user_id = $this->data['Optuser']['group'];
		}
		$this->data["Optuser"]["group"] = $this->groupName($own_user_id);
		$csv->special_cols = array(
		"Optuser/tslog"=>__('dating',$return = true),
		"Group/group_name"=>__('group_name',$return = true),
		"Host/host_name"=>__('computer_name',$return = true),
		"Optuser/account"=>__('login_account_name',$return = true),
		"Optuser/log_status"=>__('status',$return = true),
		);
		$asso = array('Host : hosts' => array('Optuser.host_id = Host.id'),
		'Rlthstgrp : rlthstgrps' => array('Optuser.host_id = Rlthstgrp.host_id'),
		'Group : groups' => array('Group.id = Rlthstgrp.group_id'),
		);
		
		//一時的にテーブルを変える
		$result = $this->Optuser->query('CREATE TEMPORARY TABLE temppsoptusers like optusers');
		if($result === false){
			debug("CREATE TEMPORARY TABLE failed!", true);
		}
		$oldtable = $this->Optuser->useTable;
		$this->Optuser->useTable = "temppsoptusers";
		$by_dt = implode(' and ', $_SESSION['by_dt']);
		if(strpos($by_dt,"- INTERVAL 1 MICROSECOND") !== false)
			$by_dt = str_replace("- INTERVAL 1 MICROSECOND","",$by_dt);
			
		$this->Optuser->queryLV("insert into temppsoptusers(host_id,account,log_status,tslog,reason,AccessFrom) select host_id,account,1,start,'','' from hstactivelogs as Hstactivelog where {$by_dt}");
		$this->Optuser->queryLV("insert into temppsoptusers(host_id,account,log_status,tslog,reason,AccessFrom) select host_id,account,case when stop is null then 100 else 2 end,case when stop is null then active else stop end,'','' from hstactivelogs as Hstactivelog where {$by_dt} and TIMESTAMPDIFF(SECOND, active, now()) > ".$interval."");

		$criteria = $_SESSION['criteri_detail'];
		for($i = 0; $i < count($criteria); $i++){
			if(strpos($criteria[$i],"Hstactivelog.account") !== false)
				$criteria[$i] = str_replace("Hstactivelog.account","Optuser.account",$criteria[$i]);
			if(strpos($criteria[$i],"Hstactivelog.start") !== false)
				$criteria[$i] = str_replace("Hstactivelog.start","Optuser.tslog",$criteria[$i]);
			if(strpos($criteria[$i],"- INTERVAL 1 MICROSECOND") !== false)
				$criteria[$i] = str_replace("- INTERVAL 1 MICROSECOND","",$criteria[$i]);
		}
		$data_detail = $this->Optuser->findByAsso($criteria, array('Group.group_name','Host.host_name','Optuser.account','Optuser.log_status','Optuser.tslog'),null,null,null,$asso);
		$data=$data_detail;
		
		
		
		$login=__("login",true);//ログオン
		$logout_status=__("logout_status",true);//ログオフ（正常?�?
		$logout_reason=__("logout_reason",true);//ログオフ�?
		$end_logout_reason=__("end_logout_reason",true);//?�?

		foreach ($data as $output){
			if($output['Optuser']['log_status'] == '1'){
				$status = $login;
			}
			elseif($output['Optuser']['log_status'] == '2'){
				$status = $logout_status;
			}
			elseif($output['Optuser']['log_status'] == '0' || $output['Optuser']['log_status'] == '100'){
				$status = $logout_reason.$output['Optuser']['reason'].$end_logout_reason;
			}
			$output_data = array(
			'Optuser' => array(
			'tslog' => $output['Optuser']['tslog'],
			'account' => $output['Optuser']['account'],
			'log_status' => $status
			),
			'Group' => array(
			'group_name' => $output['Group']['group_name'],
			),
			'Host' => array(
			'host_name' => $output['Host']['host_name'],
			)
			);
			$final_data[] = $output_data;
		}

		$csv->sendCSVFile($final_data,$this->data,__('log_onlog_off',$return = true));
	}
	function csvdown_detail_old()
	{
		require_once( 'csv/DlFactory.php' );
		$csv = DlFactory::create("oper_evtusers");
		if($this->data['Optuser']['group']=='0' || empty($this->data['Optuser']['group']))
		{
			$own_user_id = $this->_getUserGroup();
		}else
		{
			$own_user_id = $this->data['Optuser']['group'];
		}
		$this->data["Optuser"]["group"] = $this->groupName($own_user_id);
		$csv->special_cols = array(
		"Optuser/tslog"=>__('dating',$return = true),
		"Group/group_name"=>__('group_name',$return = true),
		"Host/host_name"=>__('computer_name',$return = true),
		"Optuser/account"=>__('login_account_name',$return = true),
		"Optuser/log_status"=>__('status',$return = true),
		);
		$asso = array('Host : hosts' => array('Optuser.host_id = Host.id'),
		'Rlthstgrp : rlthstgrps' => array('Optuser.host_id = Rlthstgrp.host_id'),
		'Group : groups' => array('Group.id = Rlthstgrp.group_id'),
		);
		
		//一時的にテーブルを変える
		$result = $this->Optuser->query('CREATE TEMPORARY TABLE temppsoptusers like optusers');
		if($result === false){
			debug("CREATE TEMPORARY TABLE failed!", true);
		}
$by_dt = implode(' and ', $_SESSION['by_dt']);
		$this->Optuser->query("insert into temppsoptusers select * from optusers as Optuser where {$by_dt}");

		$oldtable = $this->Optuser->useTable;
		$this->Optuser->useTable = "temppsoptusers";
		
						//追加するオフの時間を取得 acc
		$logerrs = $this->GetDisconnect2($_SESSION['criteri_3'],$asso);
		//debug($logerrs);
		foreach($logerrs as $value)
		{
			$host_id = $value[0]['Optuser']['host_id'];
			$account = $value[0]['Optuser']['account'];
			$log_status = $value[0]['Optuser']['log_status'];
			$tslog = $value[0]['Optuser']['tslog'];
			$LogonID = $value[0]['Optuser']['LogonID'];
			$AccessFrom = $value[0]['Optuser']['AccessFrom'];
			$this->Optuser->query("insert into temppsoptusers(host_id,account,log_status,tslog,LogonID,AccessFrom) values({$host_id},'{$account}',{$log_status},'{$tslog}','{$LogonID}','{$AccessFrom}')");
		}
		
		$data_detail = $this->Optuser->findByAsso($_SESSION['criteri_detail'], array('Group.group_name','Host.host_name','Optuser.account','Optuser.log_status','Optuser.tslog'),null,null,null,$asso);
		$data=$data_detail;
		
		$this->Optuser->useTable = "optusers";
		
		$login=__("login",true);//ログオン
		$logout_status=__("logout_status",true);//ログオフ（正常?�?
		$logout_reason=__("logout_reason",true);//ログオフ�?
		$end_logout_reason=__("end_logout_reason",true);//?�?

		foreach ($data as $output){
			if($output['Optuser']['log_status'] == '1'){
				$status = $login;
			}
			elseif($output['Optuser']['log_status'] == '2'){
				$status = $logout_status;
			}
			elseif($output['Optuser']['log_status'] == '0'){
				$status = $logout_reason.$output['Optuser']['reason'].$end_logout_reason;
			}
			$output_data = array(
			'Optuser' => array(
			'tslog' => $output['Optuser']['tslog'],
			'account' => $output['Optuser']['account'],
			'log_status' => $status
			),
			'Group' => array(
			'group_name' => $output['Group']['group_name'],
			),
			'Host' => array(
			'host_name' => $output['Host']['host_name'],
			)
			);
			$final_data[] = $output_data;
		}

		$csv->sendCSVFile($final_data,$this->data,__('log_onlog_off',$return = true));
	}
	function csv_detail($total=null,$type=null,$hidevar=null)
	{//件数の表示
		$this->layout='ajax';

		$hidevar=$this->Lv->url_param_decode2($hidevar);
		$this->set('total',$total);
		$this->set('hidevar',$hidevar);
		if ($type=='csvdown_detail1')
		{
			$this->csvdown_detail();
		}
	}
	
	//wasay
	function GetDisconnect($criteria3=null,$asso=null,$type=null,$crit_date=null)
	{
	//ホストごとにログオンIDで集計してログオフがないもの
		$criteriaex = $criteria3;
		$criteriaex[] = "Optuser.log_status != 0";
		$criteriaex['GROUP BY']="Optuser.host_id, Optuser.LogonID having Optuser__minst = Optuser__maxst and Optuser__minst = 1";
	
		$onwooff = $this->Optuser->findByAsso($criteriaex, array("Host.host_name as Host__host_name,Optuser.LogonID as Optuser__LogonID,lower(Optuser.account) as Optuser__account,Optuser.host_id as Optuser__host_id,Optuser.tslog as Optuser__tslog, count(*) as Optuser__cnt, max(log_status) as Optuser__maxst, min(log_status) as Optuser__minst"),null,null,null,$asso);
//debug($onwooff);
//debug($opts);

	//ログイン以降の最初の5切断を探す
		$logerrs = array();
		for ($i=0;$i<count($onwooff);$i++){
			$criteria4 = $crit_date;
			$criteria4[] = "123=123";
			$criteria4[] = "Optuser.tslog > '".$onwooff[$i]['Optuser']['tslog']."'";
			$criteria4[] = "Optuser.log_status in (3,5)";
			//$criteria4[] = "(Optuser.log_status in (3,5) or (Optuser.log_status =1 and Optuser.AccessFrom = ''))";
			$criteria4[] = "Optuser.host_id = ".$onwooff[$i]['Optuser']['host_id'];
			$startorcut = $this->Optuser->findByAsso($criteria4, array("Optuser.tslog as Optuser__tslog"),'Optuser.tslog',1,null,$asso);
			
			//あればカウント増やす
			if(count($startorcut)>0){
				if($type == 'host'){
					$name = strtolower($onwooff[$i]['Host']['host_name']);
					if(isset($logerrs[$name]))
						$logerrs[$name]++;
					else
						$logerrs[$name] = 1;
				}else if($type == 'account'){
					$name = strtolower($onwooff[$i]['Optuser']['account']);
					if(isset($logerrs[$name]))
						$logerrs[$name]++;
					else
						$logerrs[$name] = 1;
				}
			}
		}
		return $logerrs;
	}
	
	function GetDisconnectTime($criteria3=null,$asso=null,$type=null,$crit_date=null)
	{
	//ホストごとにログオンIDで集計してログオフがないもの
/*

ログオンとログオフの対応が誤ることがある


*/
		$criteriaex = $criteria3;
		$criteriaex['GROUP BY']="Optuser.host_id, Optuser.LogonID having Optuser__minst = Optuser__maxst and Optuser__minst = 1";
	
		$onwooff = $this->Optuser->findByAsso($criteriaex, array("Host.host_name as Host__host_name,Optuser.LogonID as Optuser__LogonID,lower(Optuser.account) as Optuser__account,Optuser.host_id as Optuser__host_id,Optuser.tslog as Optuser__tslog, count(*) as Optuser__cnt, max(log_status) as Optuser__maxst, min(log_status) as Optuser__minst"),null,null,null,$asso);
//debug($onwooff);
//debug($opts);

	//ログイン以降の最初の5切断を探す
		$logerrs = array();
		for ($i=0;$i<count($onwooff);$i++){
			$criteria4 = $crit_date;
			$criteria4[] = "123=123";
			$criteria4[] = "Optuser.tslog > '".$onwooff[$i]['Optuser']['tslog']."'";
			$criteria4[] = "Optuser.log_status in (3,5)";
			//$criteria4[] = "(Optuser.log_status in (3,5) or (Optuser.log_status =1 and Optuser.AccessFrom = ''))";
			$criteria4[] = "Optuser.host_id = ".$onwooff[$i]['Optuser']['host_id'];
			$startorcut = $this->Optuser->findByAsso($criteria4, array("Optuser.tslog as Optuser__tslog","TIMESTAMPDIFF(SECOND, '".$onwooff[$i]['Optuser']['tslog']."', Optuser.tslog) as Optuser__seconds"),'Optuser.tslog',1,null,$asso);
			//var_dump($startorcut);
			//あればカウント増やす
			if(count($startorcut)>0){
				$minutes = $startorcut[0]['Optuser']['seconds'] / 60;
				if($type == 'host'){
					$name = strtolower($onwooff[$i]['Host']['host_name']);
					if(isset($logerrs[$name]))
						$logerrs[$name]+=$minutes;
					else
						$logerrs[$name] = $minutes;
				}else if($type == 'account'){
					$name = strtolower($onwooff[$i]['Optuser']['account']);
					if(isset($logerrs[$name]))
						$logerrs[$name]+= $minutes;
					else
						$logerrs[$name] = $minutes;
				}
			}
		}
		return $logerrs;
	}
	
	//日付、ホストごとに切断の回数を取得
	function GetDisconnect2($criteria3=null,$asso=null,$crit_date=null)
	{
		//wasay
		//ログオフの無いものを取得
		$criteriaex = $criteria3;
		//$criteriaex[] = "Optuser.log_status != 0";
		$criteriaex['GROUP BY']="Optuser.host_id, Optuser.LogonID having Optuser__minst = Optuser__maxst and Optuser__cnt = 1";
		$criteria_new2 = array();
		foreach($criteria3 as $value)
		{
			if(false == strstr($value,"lower(Optuser.account) ="))
				$criteria_new2[] = $value;
		}
		$onwooff = $this->Optuser->findByAsso($criteriaex, 
			array("Optuser.AccessFrom as Optuser__AccessFrom",
				"Host.host_name as Host__host_name",
				"Optuser.LogonID as Optuser__LogonID",
				"lower(Optuser.account) as Optuser__account",
				"Optuser.host_id as Optuser__host_id",
				"Optuser.tslog as Optuser__tslog", 
				"count(*) as Optuser__cnt", 
				"max(log_status) as Optuser__maxst", 
				"min(log_status) as Optuser__minst"),null,null,null,$asso);
//var_dump($onwooff);

$logerrs = array();
		for ($i=0;$i<count($onwooff);$i++){
			//echo $i."<br>";
			//debug($onwooff[$i]['Optuser']);
			$criteria4 = $crit_date;$criteria4[] = "456=456";
			$criteria4[] = "Optuser.tslog > '".$onwooff[$i]['Optuser']['tslog']."'";
			$criteria4[] = "Optuser.log_status in (3,5)";
			//$criteria4[] = "(Optuser.log_status in (3,5) or (Optuser.log_status =1 and Optuser.AccessFrom = ''))";
			$criteria4[] = "Optuser.host_id = ".$onwooff[$i]['Optuser']['host_id'];
			$startorcut = $this->Optuser->findByAsso($criteria4, array("Optuser.tslog as Optuser__tslog,DATEPART(tslog) as Optuser__date,TIMEPART(tslog) as Optuser__time"),"tslog asc","limit 1",null,$asso);
			if(count($startorcut)==1){
				$startorcut[0]['Optuser']['log_status'] = 0;
				$startorcut[0]['Optuser']['con'] = 1;
				$startorcut[0]['Optuser']['AccessFrom'] = $onwooff[$i]['Optuser']['AccessFrom'];
				
				$startorcut[0]['Optuser']['host_id'] = $onwooff[$i]['Optuser']['host_id'];
				$startorcut[0]['Optuser']['account'] = $onwooff[$i]['Optuser']['account'];
				//$startorcut[0]['Optuser']['tslog'] = $onwooff[$i]['Optuser']['tslog'];

				$startorcut[0]['Optuser']['LogonID'] = $onwooff[$i]['Optuser']['LogonID'];
				
				
				$logerrs[] = $startorcut;
				
				//debug($startorcut);
			}
		}
		return $logerrs;
	}
	
	//wasay
	function GetDisconnect3($criteria3=null,$asso=null,$type=null,$crit_date=null)
	{
	//ホストごとにログオンIDで集計,ログオフがないもの
		$criteriaex = $criteria3;
		$criteriaex[] = "Optuser.log_status != 0";
		$criteriaex['GROUP BY']="Optuser.host_id, Optuser.LogonID having Optuser__minst = Optuser__maxst and Optuser__minst = 1";
	
		$onwooff = $this->Optuser->findByAsso($criteriaex, array("Host.host_name as Host__host_name,Optuser.LogonID as Optuser__LogonID,Optuser.AccessFrom as Optuser__AccessFrom,lower(Optuser.account) as Optuser__account,Optuser.host_id as Optuser__host_id,Optuser.tslog as Optuser__tslog, count(*) as Optuser__cnt, max(log_status) as Optuser__maxst, min(log_status) as Optuser__minst"),null,null,null,$asso);
//debug($onwooff);
//debug($opts);

	//ログイン以降の最初の5切断を探す
		$logerrs = array();
		for ($i=0;$i<count($onwooff);$i++){
			$criteria4 = $crit_date;
			$criteria4[] = "123=123";
			$criteria4[] = "Optuser.tslog > '".$onwooff[$i]['Optuser']['tslog']."'";
			$criteria4[] = "Optuser.log_status in (3,5)";
			//$criteria4[] = "(Optuser.log_status in (3,5) or (Optuser.log_status =1 and Optuser.AccessFrom = ''))";
			$criteria4[] = "Optuser.host_id = ".$onwooff[$i]['Optuser']['host_id'];
			$startorcut = $this->Optuser->findByAsso($criteria4, array("DATEPART(tslog) as Optuser__date, TIMEPART(tslog) as Optuser__time"),"tslog asc","limit 1",null,$asso);
		//debug($startorcut);	
			if(count($startorcut)==1){
				$startorcut[0]['Optuser']['log_status'] = 0;
				$startorcut[0]['Optuser']['con'] = 1;
				$startorcut[0]['Optuser']['AccessFrom'] = $onwooff[$i]['Optuser']['AccessFrom'];
				
				$startorcut[0]['Optuser']['host_id'] = $onwooff[$i]['Optuser']['host_id'];
				$startorcut[0]['Optuser']['account'] = $onwooff[$i]['Optuser']['account'];
				//$startorcut[0]['Optuser']['tslog'] = $onwooff[$i]['Optuser']['tslog'];

				$startorcut[0]['Optuser']['LogonID'] = $onwooff[$i]['Optuser']['LogonID'];
				
				
				$logerrs[] = $startorcut[0];
				
				//debug($startorcut);
			}
		}
		return $logerrs;
	}
	
	function getParentschedule($groupid)
	{
		$default = $this->Grpshd->find(array("group_id" => $groupid),
			array('Grpshd.id','Grpshd.group_id',
				'Grpshd.start_date','Grpshd.end_date','Grpshd.start_time','Grpshd.end_time',
				'Grpshd.weekday','Grpshd.onlogon',
				'timediff(end_time,start_time) as Grpshd__time_diff',
				'time_to_sec(timediff(end_time,start_time)) as Grpshd__second_diff'));
		if(empty($default))
		{
			$parent = $this->Group->group_father_id($groupid);
			if(!empty($parent))
				$default = $this->getParentschedule($parent);
		}
		return $default;
	}
	
	function getInterval(){
		$interval = SCHEDULE_AGENT; 
		$conf = $this->getParentschedule(1);
		if(!empty($conf)){
			$sch_id = $conf['Grpshd']['id'];
			$agent = $this->Rltshdmod->find(array("Rltshdmod.sch_id" => $sch_id, "Rltshdmod.module_id" => 20));

			if(isset($agent['Rltshdmod']['inter_time']))
				$interval = $agent['Rltshdmod']['inter_time']; 
			else
				$interval = SCHEDULE_AGENT; 
		}
		return $interval*2;
	}
}
?>